Index: /gli/trunk/src/org/greenstone/gatherer/remote/RemoteGreenstoneServer.java
===================================================================
--- /gli/trunk/src/org/greenstone/gatherer/remote/RemoteGreenstoneServer.java	(revision 17611)
+++ /gli/trunk/src/org/greenstone/gatherer/remote/RemoteGreenstoneServer.java	(revision 17612)
@@ -413,577 +317,6 @@
 
     // ----------------------------------------------------------------------------------------------------
-    //   ACTIONS
-    // ----------------------------------------------------------------------------------------------------
-
-
-    static private abstract class RemoteGreenstoneServerAction
-    {
-	public String action_output = null;
-	public boolean processed = false;
-	public boolean processed_successfully;
-
-	abstract public void perform()
-	    throws Exception;
-    }
-
-
-    static private class RemoteGreenstoneServerActionCancelledException
-	extends Exception
-    {
-    }
-
-
-    /**
-     * --------------------------------------------------------------------------------------------
-     *    DELETE COLLECTION
-     * --------------------------------------------------------------------------------------------
-     */
-    static private class RemoteGreenstoneServerDeleteCollectionAction
-	extends RemoteGreenstoneServerAction
-    {
-	private String collection_name;
-
-	public RemoteGreenstoneServerDeleteCollectionAction(String collection_name)
-	{
-	    this.collection_name = collection_name;
-	}
-
-	public void perform()
-	    throws Exception
-	{
-	    progress_bar.setAction("Deleting collection " + collection_name + "...");
-
-	    String delete_collection_command = "cmd=delete-collection";
-	    delete_collection_command += "&c=" + URLEncoder.encode(collection_name, "UTF-8");
-	    action_output = sendCommandToServer(delete_collection_command, null);
-	}
-    }
-
-
-    /**
-     * --------------------------------------------------------------------------------------------
-     *    DELETE COLLECTION FILE
-     * --------------------------------------------------------------------------------------------
-     */
-    static private class RemoteGreenstoneServerDeleteCollectionFileAction
-	extends RemoteGreenstoneServerAction
-    {
-	private String collection_name;
-	private File collection_file;
-
-	public RemoteGreenstoneServerDeleteCollectionFileAction(String collection_name, File collection_file)
-	{
-	    this.collection_name = collection_name;
-	    this.collection_file = collection_file;
-	}
-
-	public void perform()
-	    throws Exception
-	{
-	    String collection_directory_path = CollectionManager.getCollectionDirectoryPath(collection_name);
-	    String collection_file_relative_path = getPathRelativeToDirectory(collection_file, collection_directory_path);
-	    collection_file_relative_path = collection_file_relative_path.replaceAll((Utility.isWindows() ? "\\\\" : "\\/"), "|");
-	    progress_bar.setAction("Deleting collection file " + collection_file_relative_path + "...");
-
-	    String delete_collection_file_command = "cmd=delete-collection-file";
-	    delete_collection_file_command += "&c=" + URLEncoder.encode(collection_name, "UTF-8");
-	    delete_collection_file_command += "&file=" + URLEncoder.encode(collection_file_relative_path, "UTF-8");
-	    action_output = sendCommandToServer(delete_collection_file_command, null);
-	}
-    }
-
-
-    /**
-     * --------------------------------------------------------------------------------------------
-     *    DOWNLOAD COLLECTION
-     * --------------------------------------------------------------------------------------------
-     */
-    static private class RemoteGreenstoneServerDownloadCollectionAction
-	extends RemoteGreenstoneServerAction
-    {
-	private String collection_name;
-
-	public RemoteGreenstoneServerDownloadCollectionAction(String collection_name)
-	{
-	    this.collection_name = collection_name;
-	}
-
-	public void perform()
-	    throws Exception
-	{
-	    progress_bar.setAction("Downloading remote collection " + collection_name + "...");
-
-	    String download_collection_command = "cmd=download-collection";
-	    download_collection_command += "&c=" + URLEncoder.encode(collection_name, "UTF-8");
-	    String zip_file_path = Gatherer.getCollectDirectoryPath() + collection_name + ".zip";
-	    action_output = downloadFile(download_collection_command, zip_file_path);
-
-	    // Delete the existing (local) collection directory
-	    Utility.delete(new File(CollectionManager.getCollectionDirectoryPath(collection_name)));
-
-	    // Unzip the collection just downloaded
-	    UnzipTools.unzipFile(zip_file_path, Gatherer.getCollectDirectoryPath());
-	}
-    }
-
-
-    /**
-     * --------------------------------------------------------------------------------------------
-     *    DOWNLOAD COLLECTION ARCHIVES
-     * --------------------------------------------------------------------------------------------
-     */
-    static private class RemoteGreenstoneServerDownloadCollectionArchivesAction
-	extends RemoteGreenstoneServerAction
-    {
-	private String collection_name;
-
-	public RemoteGreenstoneServerDownloadCollectionArchivesAction(String collection_name)
-	{
-	    this.collection_name = collection_name;
-	}
-
-	public void perform()
-	    throws Exception
-	{
-	    progress_bar.setAction("Downloading collection archives for " + collection_name + "...");
-
-	    String download_collection_archives_command = "cmd=download-collection-archives";
-	    download_collection_archives_command += "&c=" + URLEncoder.encode(collection_name, "UTF-8");
-	    String zip_file_path = Gatherer.getCollectDirectoryPath() + collection_name + "-archives.zip";
-	    action_output = downloadFile(download_collection_archives_command, zip_file_path);
-
-	    // Delete the existing (local) collection archives
-	    Utility.delete(new File(CollectionManager.getLoadedCollectionArchivesDirectoryPath()));
-
-	    // Unzip the collection archives just downloaded
-	    UnzipTools.unzipFile(zip_file_path, Gatherer.getCollectDirectoryPath());
-	}
-    }
-
-
-    /**
-     * --------------------------------------------------------------------------------------------
-     *    DOWNLOAD COLLECTION CONFIGURATIONS
-     * --------------------------------------------------------------------------------------------
-     */
-    static private class RemoteGreenstoneServerDownloadCollectionConfigurationsAction
-	extends RemoteGreenstoneServerAction
-    {
-	public RemoteGreenstoneServerDownloadCollectionConfigurationsAction()
-	{
-	}
-
-	public void perform()
-	    throws Exception
-	{
-	    progress_bar.setAction("Downloading collection configurations...");
-
-	    // Delete the existing (local) collect directory
-	    Utility.delete(new File(Gatherer.getCollectDirectoryPath()));
-	    new File(Gatherer.getCollectDirectoryPath()).mkdirs();
-
-	    String download_collection_configurations_command = "cmd=download-collection-configurations";
-	    String zip_file_path = Gatherer.getCollectDirectoryPath() + "collections.zip";
-	    action_output = downloadFile(download_collection_configurations_command, zip_file_path);
-
-	    // Unzip the collection configurations just downloaded
-	    UnzipTools.unzipFile(zip_file_path, Gatherer.getCollectDirectoryPath());
-	}
-    }
-
-     /**
-     * --------------------------------------------------------------------------------------------
-     *    DISCOVERING WHAT VERSION THE REMOTE GREENSTONE SERVER IS (2 or 3)
-     * --------------------------------------------------------------------------------------------
-     */
-
-    static private class RemoteGreenstoneServerVersionAction
-	extends RemoteGreenstoneServerAction
-    {
-	public void perform()
-	    throws Exception
-	{
-	    action_output = sendCommandToServer("cmd=greenstone-server-version", null);
-	}	
-    }
-
-    static private class RemoteGreenstoneServerLibraryURLSuffixAction
-	extends RemoteGreenstoneServerAction
-    {
-	public void perform()
-	    throws Exception
-	{
-	    action_output = sendCommandToServer("cmd=get-library-url-suffix", null);
-	}	
-    }
-    
-    /**
-     * --------------------------------------------------------------------------------------------
-     *    CHECKING IF A FILE/FOLDER EXISTS ON SERVER SIDE
-     * --------------------------------------------------------------------------------------------
-     */
-    static private class RemoteGreenstoneServerExistsAction 
-	extends RemoteGreenstoneServerAction
-    {
-	private String collection_name;
-	private File collection_file;
-	
-	public RemoteGreenstoneServerExistsAction(String collection_name, File collection_file)
-	{
-	    this.collection_name = collection_name;
-	    this.collection_file = collection_file;
-	}
-	
-	public void perform()
-	    throws Exception
-	{
-	    String collection_directory_path = CollectionManager.getCollectionDirectoryPath(collection_name);
-	    String collection_file_relative_path = getPathRelativeToDirectory(collection_file, collection_directory_path);
-	    collection_file_relative_path = collection_file_relative_path.replaceAll((Utility.isWindows() ? "\\\\" : "\\/"), "|");
-	    File file = new File(collection_directory_path, collection_file_relative_path);
-
-	    String file_exists_command = "cmd=file-exists";
-	    file_exists_command += "&c=" + URLEncoder.encode(collection_name, "UTF-8");
-	    file_exists_command += "&file=" + URLEncoder.encode(collection_file_relative_path, "UTF-8");
-	    // returns either "File <filename> exists" or "File <filename> does not exist"
-	    // for the file/folder collection_file
-	    action_output = sendCommandToServer(file_exists_command, null);
-	}	
-    }
-    
-
-    /**
-     * --------------------------------------------------------------------------------------------
-     *    DOWNLOAD COLLECTION FILE
-     * --------------------------------------------------------------------------------------------
-     */
-    static private class RemoteGreenstoneServerDownloadCollectionFileAction
-	extends RemoteGreenstoneServerAction
-    {
-	private String collection_name;
-	private File collection_file;
-
-	public RemoteGreenstoneServerDownloadCollectionFileAction(String collection_name, File collection_file)
-	{
-	    this.collection_name = collection_name;
-	    this.collection_file = collection_file;
-	}
-
-	public void perform()
-	    throws Exception
-	{
-	    String collection_directory_path = CollectionManager.getCollectionDirectoryPath(collection_name);
-	    String collection_file_relative_path = getPathRelativeToDirectory(collection_file, collection_directory_path);
-	    collection_file_relative_path = collection_file_relative_path.replaceAll((Utility.isWindows() ? "\\\\" : "\\/"), "|");
-	    progress_bar.setAction("Downloading collection file " + collection_file_relative_path + "...");
-
-	    String download_collection_file_command = "cmd=download-collection-file";
-	    download_collection_file_command += "&c=" + URLEncoder.encode(collection_name, "UTF-8");
-	    download_collection_file_command += "&file=" + URLEncoder.encode(collection_file_relative_path, "UTF-8");
-	    String zip_file_name = collection_name + "-" + collection_file.getName() + ".zip";
-	    String zip_file_path = collection_directory_path + zip_file_name;
-	    action_output = downloadFile(download_collection_file_command, zip_file_path);
-
-	    // Unzip the collection file just downloaded
-	    UnzipTools.unzipFile(zip_file_path, collection_directory_path);
-	}
-    }
-
-    /**
-     * --------------------------------------------------------------------------------------------
-     *    DOWNLOAD web.xml FILE --for a remote GS3
-     * --------------------------------------------------------------------------------------------
-     */
-    static private class RemoteGreenstoneServerDownloadWebXMLFileAction
-	extends RemoteGreenstoneServerAction
-    {
-	public RemoteGreenstoneServerDownloadWebXMLFileAction()
-	{}
-
-	public void perform()
-	    throws Exception
-	{
-	    String web_xml_directory_path=(Configuration.gli_user_directory_path);
-	    String download_web_xml_file_command = "cmd=download-web-xml-file";
-	    download_web_xml_file_command += "&file=" + URLEncoder.encode("web.xml", "UTF-8");
-	    String zip_file_name = "web-xml.zip";
-	    String zip_file_path = web_xml_directory_path + zip_file_name;
-	    action_output = downloadFile(download_web_xml_file_command, zip_file_path);
-
-	    // Unzip the web.xml file just downloaded
-	    UnzipTools.unzipFile(zip_file_path,web_xml_directory_path);
-	}
-    }
-
-    /**
-     * --------------------------------------------------------------------------------------------
-     *    GET SCRIPT OPTIONS
-     * --------------------------------------------------------------------------------------------
-     */
-    static private class RemoteGreenstoneServerGetScriptOptionsAction
-	extends RemoteGreenstoneServerAction
-    {
-	private String script_name;
-	private String script_arguments;
-
-	public RemoteGreenstoneServerGetScriptOptionsAction(String script_name, String script_arguments)
-	{
-	    this.script_name = script_name;
-	    this.script_arguments = script_arguments;
-	}
-
-	public void perform()
-	    throws Exception
-	{
-	    progress_bar.setAction("Getting options for " + script_name + "...");
-
-	    String get_script_options_command = "cmd=get-script-options";
-	    get_script_options_command += "&script=" + script_name;
-	    get_script_options_command += "&xml=";
-	    get_script_options_command += "&language=" + Configuration.getLanguage();
-	    get_script_options_command += script_arguments;
-	    action_output = sendCommandToServer(get_script_options_command, null);
-	}
-    }
-
-    /**
-     * --------------------------------------------------------------------------------------------
-     *    GET ALL NAMES OF SITES // for a remote GS3 
-     * --------------------------------------------------------------------------------------------
-     */
-    static private class RemoteGreenstoneServerGetSiteNamesAction
-	extends RemoteGreenstoneServerAction
-    {
-	public RemoteGreenstoneServerGetSiteNamesAction()
-	{}
-
-	public void perform()
-	    throws Exception
-	{
-	    progress_bar.setAction("Getting names of sites ...");
-
-	    String get_script_options_command = "cmd=get-site-names";
-	    action_output = sendCommandToServer(get_script_options_command, null);
-	}
-    }
-
-    /**
-     * --------------------------------------------------------------------------------------------
-     *    MOVE COLLECTION FILE
-     * --------------------------------------------------------------------------------------------
-     */
-    static private class RemoteGreenstoneServerMoveCollectionFileAction
-	extends RemoteGreenstoneServerAction
-    {
-	private String collection_name;
-	private File source_collection_file;
-	private File target_collection_file;
-
-	public RemoteGreenstoneServerMoveCollectionFileAction(String collection_name, File source_collection_file, File target_collection_file)
-	{
-	    this.collection_name = collection_name;
-	    this.source_collection_file = source_collection_file;
-	    this.target_collection_file = target_collection_file;
-	}
-
-	public void perform()
-	    throws Exception
-	{
-	    String collection_directory_path = CollectionManager.getCollectionDirectoryPath(collection_name);
-	    String source_collection_file_relative_path = getPathRelativeToDirectory(source_collection_file, collection_directory_path);
-	    source_collection_file_relative_path = source_collection_file_relative_path.replaceAll((Utility.isWindows() ? "\\\\" : "\\/"), "|");
-	    String target_collection_file_relative_path = getPathRelativeToDirectory(target_collection_file, collection_directory_path);
-	    target_collection_file_relative_path = target_collection_file_relative_path.replaceAll((Utility.isWindows() ? "\\\\" : "\\/"), "|");
-	    progress_bar.setAction("Moving file " + source_collection_file_relative_path + " -> " + target_collection_file_relative_path + "...");
-
-	    String move_collection_file_command = "cmd=move-collection-file";
-	    move_collection_file_command += "&c=" + URLEncoder.encode(collection_name, "UTF-8");
-	    move_collection_file_command += "&source=" + URLEncoder.encode(source_collection_file_relative_path, "UTF-8");
-	    move_collection_file_command += "&target=" + URLEncoder.encode(target_collection_file_relative_path, "UTF-8");
-	    action_output = sendCommandToServer(move_collection_file_command, null);
-	}
-    }
-
-
-    /**
-     * --------------------------------------------------------------------------------------------
-     *    NEW COLLECTION DIRECTORY
-     * --------------------------------------------------------------------------------------------
-     */
-    static private class RemoteGreenstoneServerNewCollectionDirectoryAction
-	extends RemoteGreenstoneServerAction
-    {
-	private String collection_name;
-	private File new_collection_directory;
-
-	public RemoteGreenstoneServerNewCollectionDirectoryAction(String collection_name, File new_collection_directory)
-	{
-	    this.collection_name = collection_name;
-	    this.new_collection_directory = new_collection_directory;
-	}
-
-	public void perform()
-	    throws Exception
-	{
-	    String collection_directory_path = CollectionManager.getCollectionDirectoryPath(collection_name);
-	    String new_collection_directory_relative_path = getPathRelativeToDirectory(new_collection_directory, collection_directory_path);
-	    new_collection_directory_relative_path = new_collection_directory_relative_path.replaceAll((Utility.isWindows() ? "\\\\" : "\\/"), "|");
-	    progress_bar.setAction("Creating new directory " + new_collection_directory_relative_path + "...");
-
-	    String new_collection_directory_command = "cmd=new-collection-directory";
-	    new_collection_directory_command += "&c=" + URLEncoder.encode(collection_name, "UTF-8");
-	    new_collection_directory_command += "&directory=" + URLEncoder.encode(new_collection_directory_relative_path, "UTF-8");
-	    action_output = sendCommandToServer(new_collection_directory_command, null);
-	}
-    }
-
-
-    /**
-     * --------------------------------------------------------------------------------------------
-     *    RUN SCRIPT
-     * --------------------------------------------------------------------------------------------
-     */
-    static private class RemoteGreenstoneServerRunScriptAction
-	extends RemoteGreenstoneServerAction
-    {
-	private String collection_name;
-	private String script_name;
-	private String script_arguments;
-	private GShell shell;
-
-	public RemoteGreenstoneServerRunScriptAction(String collection_name, String script_name, String script_arguments, GShell shell)
-	{
-	    this.collection_name = collection_name;
-	    this.script_name = script_name;
-	    this.script_arguments = script_arguments;
-	    this.shell = shell;
-	}
-
-	public void perform()
-	    throws Exception
-	{
-	    progress_bar.setAction("Running " + script_name + "...");
-
-	    String run_script_command = "cmd=run-script";
-	    run_script_command += "&c=" + URLEncoder.encode(collection_name, "UTF-8");
-	    run_script_command += "&script=" + script_name;
-	    run_script_command += "&language=" + Configuration.getLanguage();
-	    run_script_command += script_arguments;
-	    action_output = sendCommandToServer(run_script_command, shell);
-	}
-    }
-
-
-    /**
-     * --------------------------------------------------------------------------------------------
-     *    UPLOAD COLLECTION FILE
-     * --------------------------------------------------------------------------------------------
-     */
-    static private class RemoteGreenstoneServerUploadCollectionFilesAction
-	extends RemoteGreenstoneServerAction
-    {
-	private String collection_name;
-	private File[] collection_files;
-
-
-	public RemoteGreenstoneServerUploadCollectionFilesAction(String collection_name, File[] collection_files)
-	{
-	    this.collection_name = collection_name;
-	    this.collection_files = collection_files;
-	}
-
-
-	public void perform()
-	    throws Exception
-	{
-	    progress_bar.setAction("Uploading collection files...");
-
-	    // Determine the file paths relative to the collection directory
-	    String collection_directory_path = CollectionManager.getCollectionDirectoryPath(collection_name);
-	    String[] collection_file_relative_paths = new String[collection_files.length];
-	    for (int i = 0; i < collection_files.length; i++) {
-		collection_file_relative_paths[i] = getPathRelativeToDirectory(collection_files[i], collection_directory_path);
-	    }
-
-	    // Zip up the files to send to the server
-	    String zip_file_name = collection_name + "-" + System.currentTimeMillis() + ".zip";
-	    String zip_file_path = collection_directory_path + zip_file_name;
-	    ZipTools.zipFiles(zip_file_path, collection_directory_path, collection_file_relative_paths);
-	    
-	    // Upload the zip file
-	    String upload_collection_file_command = "cmd=upload-collection-file";
-	    upload_collection_file_command += "&c=" + URLEncoder.encode(collection_name, "UTF-8");
-	    upload_collection_file_command += "&file=" + URLEncoder.encode(zip_file_name, "UTF-8");
-	    upload_collection_file_command += "&directory=";
-	    upload_collection_file_command += "&zip=true";
-	    action_output = uploadFile(upload_collection_file_command, zip_file_path);
-	}
-    }
-
-
-    /**
-     * --------------------------------------------------------------------------------------------
-     *    UPLOAD FILES INTO COLLECTION
-     * --------------------------------------------------------------------------------------------
-     */
-    static private class RemoteGreenstoneServerUploadFilesIntoCollectionAction
-	extends RemoteGreenstoneServerAction
-    {
-	private String collection_name;
-	private File[] source_files;
-	private File target_collection_directory;
-
-
-	public RemoteGreenstoneServerUploadFilesIntoCollectionAction(String collection_name, File[] source_files, File target_collection_directory)
-	{
-	    this.collection_name = collection_name;
-	    this.source_files = source_files;
-	    this.target_collection_directory = target_collection_directory;
-	}
-
-
-	public void perform()
-	    throws Exception
-	{
-	    String collection_directory_path = CollectionManager.getCollectionDirectoryPath(collection_name);
-	    String target_collection_directory_relative_path = getPathRelativeToDirectory(target_collection_directory, collection_directory_path);
-	    target_collection_directory_relative_path = target_collection_directory_relative_path.replaceAll((Utility.isWindows() ? "\\\\" : "\\/"), "|");
-	    progress_bar.setAction("Uploading files into collection...");
-	   
-	    String zip_file_name = collection_name + "-" + System.currentTimeMillis() + ".zip";
-	    String zip_file_path = Gatherer.getCollectDirectoryPath() + zip_file_name;
-	    DebugStream.println("Zip file path: " + zip_file_path);
-
-	    String base_directory_path = source_files[0].getParentFile().getAbsolutePath();
-	    DebugStream.println("Base directory path: " + base_directory_path);
-	    String[] source_file_relative_paths = new String[source_files.length];
-	    for (int i = 0; i < source_files.length; i++) {
-		DebugStream.println("Source file path: " + source_files[i]);
-		source_file_relative_paths[i] = getPathRelativeToDirectory(source_files[i], base_directory_path);
-	    }
-	    
-	    ZipTools.zipFiles(zip_file_path, base_directory_path, source_file_relative_paths);
-
-	    String upload_collection_file_command = "cmd=upload-collection-file";
-	    upload_collection_file_command += "&c=" + URLEncoder.encode(collection_name, "UTF-8");
-	    upload_collection_file_command += "&file=" + URLEncoder.encode(zip_file_name, "UTF-8");
-	    upload_collection_file_command += "&directory=" + URLEncoder.encode(target_collection_directory_relative_path, "UTF-8");
-	    upload_collection_file_command += "&zip=true";
-	    action_output = uploadFile(upload_collection_file_command, zip_file_path);
-	}
-    }
-
-
-    // ----------------------------------------------------------------------------------------------------
     //   AUTHENTICATION LAYER
     // ----------------------------------------------------------------------------------------------------
-
-
-    static private PasswordAuthentication remote_greenstone_server_authentication = null;
-    // static private PasswordAuthentication remote_greenstone_server_authentication = new PasswordAuthentication(System.getProperty("user.name"), new char[] { });
-
-    static public void set_remote_greenstone_server_authentication_to_null(){
-	remote_greenstone_server_authentication = null;
-    }
 
     static private class RemoteGreenstoneServerAuthenticateTask
@@ -1018,8 +351,11 @@
  	}
     }
-
-
-    static private void authenticateUser()
-	throws RemoteGreenstoneServerActionCancelledException
+    
+    public void set_remote_greenstone_server_authentication_to_null() {
+	remote_greenstone_server_authentication = null;
+    }
+
+    private void authenticateUser()
+	throws RemoteGreenstoneServerAction.ActionCancelledException
     {
 	// If we don't have any authentication information then ask for it now
@@ -1035,11 +371,11 @@
 	    // If it is still null then the user has cancelled the authentication, so the action is cancelled
 	    if (remote_greenstone_server_authentication == null) {
-		throw new RemoteGreenstoneServerActionCancelledException();
-	    }
-	}
-    }
-
-
-    static public String getUsername()
+		throw new RemoteGreenstoneServerAction.ActionCancelledException();
+	    }
+	}
+    }
+
+
+    public String getUsername()
     {
 	if (remote_greenstone_server_authentication != null) {
@@ -1057,5 +393,5 @@
 
     /** Returns the command output if the action completed, throws some kind of exception otherwise. */
-    static private String downloadFile(String gliserver_args, String file_path)
+    String downloadFile(String gliserver_args, String file_path)
 	throws Exception
     {
@@ -1081,5 +417,5 @@
 		if (JOptionPane.showConfirmDialog(Gatherer.g_man, Dictionary.get("RemoteGreenstoneServer.Steal_Lock_Message", command_output.substring("ERROR: Collection is locked by: ".length())), Dictionary.get("RemoteGreenstoneServer.Error_Title"), JOptionPane.YES_NO_OPTION) == JOptionPane.NO_OPTION) {
 		    // The user has decided to cancel the action
-		    throw new RemoteGreenstoneServerActionCancelledException();
+		    throw new RemoteGreenstoneServerAction.ActionCancelledException();
 		}
 
@@ -1101,5 +437,5 @@
      * string embedded in the given gliserver_args. No authentication is required for either 
      * of the commands greenstone-server-version and get-library-url-suffix. */
-    static private boolean isAuthenticationRequired(String gliserver_args) {
+    private boolean isAuthenticationRequired(String gliserver_args) {
 	return ((gliserver_args.indexOf("greenstone-server-version") == -1) 
 		&& (gliserver_args.indexOf("get-library-url-suffix") == -1));
@@ -1107,6 +443,8 @@
 
 
-    /** Returns the command output if the action completed, throws some kind of exception otherwise. */
-    static private String sendCommandToServer(String gliserver_args, GShell shell)
+    /** Returns the command output if the action completed, throws some kind of exception otherwise. 
+     *  Package access, so that RemoteGreenstoneServerAction.java can call this.
+     */
+    String sendCommandToServer(String gliserver_args, GShell shell)
 	throws Exception
     {
@@ -1135,5 +473,5 @@
 		if (JOptionPane.showConfirmDialog(Gatherer.g_man, Dictionary.get("RemoteGreenstoneServer.Steal_Lock_Message", command_output.substring("ERROR: Collection is locked by: ".length())), Dictionary.get("RemoteGreenstoneServer.Error_Title"), JOptionPane.YES_NO_OPTION) == JOptionPane.NO_OPTION) {
 		    // The user has decided to cancel the action
-		    throw new RemoteGreenstoneServerActionCancelledException();
+		    throw new RemoteGreenstoneServerAction.ActionCancelledException();
 		}
 
@@ -1157,5 +495,5 @@
 
     /** Returns the command output if the action completed, throws some kind of exception otherwise. */
-    static private String uploadFile(String gliserver_args, String file_path)
+    String uploadFile(String gliserver_args, String file_path)
 	throws Exception
     {
@@ -1182,5 +520,5 @@
 		if (JOptionPane.showConfirmDialog(Gatherer.g_man, Dictionary.get("RemoteGreenstoneServer.Steal_Lock_Message", command_output.substring("ERROR: Collection is locked by: ".length())), Dictionary.get("RemoteGreenstoneServer.Error_Title"), JOptionPane.YES_NO_OPTION) == JOptionPane.NO_OPTION) {
 		    // The user has decided to cancel the action
-		    throw new RemoteGreenstoneServerActionCancelledException();
+		    throw new RemoteGreenstoneServerAction.ActionCancelledException();
 		}
 
@@ -1206,5 +544,5 @@
 
     /** Returns the command output if the action completed, throws some kind of exception otherwise. */
-    static private String downloadFileInternal(String download_cgi, String cgi_args, String file_path)
+    private String downloadFileInternal(String download_cgi, String cgi_args, String file_path)
 	throws Exception
     {
@@ -1262,5 +600,5 @@
 
     /** Returns the command output if the action completed, throws some kind of exception otherwise. */
-    static private String sendCommandToServerInternal(String gliserver_url_string, String cgi_args, GShell shell)
+    private String sendCommandToServerInternal(String gliserver_url_string, String cgi_args, GShell shell)
 	throws Exception
     {
@@ -1290,5 +628,5 @@
 		shell.fireMessage(gliserver_output_line);
 		if (shell.hasSignalledStop()) {
-		    throw new RemoteGreenstoneServerActionCancelledException();
+		    throw new RemoteGreenstoneServerAction.ActionCancelledException();
 		}
 	    }
@@ -1303,5 +641,5 @@
 	       
     /** Returns the command output if the action completed, throws some kind of exception otherwise. */
-    static private String uploadFileInternal(String upload_cgi, String cgi_args, String file_path)
+    private String uploadFileInternal(String upload_cgi, String cgi_args, String file_path)
 	throws Exception
     {
@@ -1433,5 +771,5 @@
 
 
-    static public String getPathRelativeToDirectory(File file, String directory_path)
+    public String getPathRelativeToDirectory(File file, String directory_path)
     {
 	String file_path = file.getAbsolutePath();
